/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookEventConversationCustomData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventConversationCustomData{}

// WebhookEventConversationCustomData struct for WebhookEventConversationCustomData
type WebhookEventConversationCustomData struct {
	Locale *string `json:"locale,omitempty"`
	TransactionId *string `json:"transaction_id,omitempty"`
	// Here you can find entry point data
	Data *map[string][]string `json:"data,omitempty"`
}

// NewWebhookEventConversationCustomData instantiates a new WebhookEventConversationCustomData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventConversationCustomData() *WebhookEventConversationCustomData {
	this := WebhookEventConversationCustomData{}
	return &this
}

// NewWebhookEventConversationCustomDataWithDefaults instantiates a new WebhookEventConversationCustomData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventConversationCustomDataWithDefaults() *WebhookEventConversationCustomData {
	this := WebhookEventConversationCustomData{}
	return &this
}

// GetLocale returns the Locale field value if set, zero value otherwise.
func (o *WebhookEventConversationCustomData) GetLocale() string {
	if o == nil || IsNil(o.Locale) {
		var ret string
		return ret
	}
	return *o.Locale
}

// GetLocaleOk returns a tuple with the Locale field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventConversationCustomData) GetLocaleOk() (*string, bool) {
	if o == nil || IsNil(o.Locale) {
		return nil, false
	}
	return o.Locale, true
}

// HasLocale returns a boolean if a field has been set.
func (o *WebhookEventConversationCustomData) HasLocale() bool {
	if o != nil && !IsNil(o.Locale) {
		return true
	}

	return false
}

// SetLocale gets a reference to the given string and assigns it to the Locale field.
func (o *WebhookEventConversationCustomData) SetLocale(v string) {
	o.Locale = &v
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *WebhookEventConversationCustomData) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventConversationCustomData) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *WebhookEventConversationCustomData) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *WebhookEventConversationCustomData) SetTransactionId(v string) {
	o.TransactionId = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *WebhookEventConversationCustomData) GetData() map[string][]string {
	if o == nil || IsNil(o.Data) {
		var ret map[string][]string
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventConversationCustomData) GetDataOk() (*map[string][]string, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *WebhookEventConversationCustomData) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given map[string][]string and assigns it to the Data field.
func (o *WebhookEventConversationCustomData) SetData(v map[string][]string) {
	o.Data = &v
}

func (o WebhookEventConversationCustomData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventConversationCustomData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Locale) {
		toSerialize["locale"] = o.Locale
	}
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableWebhookEventConversationCustomData struct {
	value *WebhookEventConversationCustomData
	isSet bool
}

func (v NullableWebhookEventConversationCustomData) Get() *WebhookEventConversationCustomData {
	return v.value
}

func (v *NullableWebhookEventConversationCustomData) Set(val *WebhookEventConversationCustomData) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventConversationCustomData) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventConversationCustomData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventConversationCustomData(val *WebhookEventConversationCustomData) *NullableWebhookEventConversationCustomData {
	return &NullableWebhookEventConversationCustomData{value: val, isSet: true}
}

func (v NullableWebhookEventConversationCustomData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventConversationCustomData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


